// // // // // // // // // // // // //
//
//	Spieler
//
//	erstellt 31.12.97 von Andreas Warnke
//	geändert 15.4.97 von Andreas Warnke
//



// // // // // // // // // // // // //
//
//	include
//

#include "Spieler.h"
#include "AsciiKette.h"



// // // // // // // // // // // // //
//
//	Konstruktoren
//

Spieler :: Spieler ()
{
	DerName = NULL;
	DieID = 0;
	DasPasswort = NULL;
	DieVersion = 0;
	DasReadOnlyPasswort = NULL;
	readOnly = true;
};

Spieler :: Spieler ( 
	const char * inName,
	const char * inPassword,
	const char * inReadOnlyPassword,
	bool inReadOnly,
	unsigned int inVersion,
	unsigned int inID,
 	BMessenger inAddress )
{
	DerName = Concat ( inName, NULL );
	DieID = inID;
	DasPasswort = Concat ( inPassword, NULL );
	DieVersion = inVersion;
	DerBote = inAddress;
	alive = true;
	readOnly = inReadOnly;
	if ( inReadOnlyPassword == NULL )
		DasReadOnlyPasswort = NULL;
	else
		DasReadOnlyPasswort = Concat ( inReadOnlyPassword, NULL );
};
	

	
// // // // // // // // // // // // //
//
//	Destruktor
//

Spieler :: ~Spieler ()
{
	if ( DerName != NULL )
	{
		delete [] DerName;
		DerName = NULL;
	};
	DieID = 0;
	if ( DasPasswort != NULL )
	{
		delete [] DasPasswort;
		DasPasswort = NULL;
	};
	if ( DasReadOnlyPasswort != NULL )
	{
		delete [] DasReadOnlyPasswort;
		DasReadOnlyPasswort = NULL;
	};
	DieVersion = 0;
	alive = false;
};


	
//
//	Ende
//
// // // // // // // // // // // // //